package io.renren.modules.sys.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.renren.common.annotation.LogOperation;
import io.renren.common.constant.Constant;
import io.renren.common.exception.RenException;
import io.renren.common.page.PageData;
import io.renren.common.utils.DateUtils;
import io.renren.common.utils.ExcelUtils;
import io.renren.common.utils.Result;
import io.renren.common.validator.AssertUtils;
import io.renren.common.validator.ValidatorUtils;
import io.renren.common.validator.group.AddGroup;
import io.renren.common.validator.group.DefaultGroup;
import io.renren.common.validator.group.UpdateGroup;
import io.renren.modules.security.user.SecurityUser;
import io.renren.modules.security.user.UserDetail;
import io.renren.modules.sys.dao.RdAdvertiserDao;
import io.renren.modules.sys.dto.BudgetDTO;
import io.renren.modules.sys.dto.ScopeCityCostDTO;
import io.renren.modules.sys.entity.RdAdvertiserEntity;
import io.renren.modules.sys.excel.ScopeCityCostExcel;
import io.renren.modules.sys.service.ScopeCityCostService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.CollectionUtils;
import org.springframework.web.bind.annotation.*;
import springfox.documentation.annotations.ApiIgnore;

import javax.servlet.http.HttpServletResponse;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * 受众城市单价
 *
 * @author Mark sunlightcs@gmail.com
 * @since 1.0.0 2022-05-28
 */
@RestController
@RequestMapping("sys/scopecitycost")
@Api(tags="受众城市单价")
public class ScopeCityCostController {
    @Autowired
    private ScopeCityCostService scopeCityCostService;
    @Autowired
    private RdAdvertiserDao rdAdvertiserDao;

    @GetMapping("page")
    @ApiOperation("分页")
    @ApiImplicitParams({
        @ApiImplicitParam(name = Constant.PAGE, value = "当前页码，从1开始", paramType = "query", required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.LIMIT, value = "每页显示记录数", paramType = "query",required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.ORDER_FIELD, value = "排序字段", paramType = "query", dataType="String") ,
        @ApiImplicitParam(name = Constant.ORDER, value = "排序方式，可选值(asc、desc)", paramType = "query", dataType="String")
    })
    @RequiresPermissions("sys:scopecitycost:page")
    public Result<PageData<ScopeCityCostDTO>> page(@ApiIgnore @RequestParam Map<String, Object> params){
        PageData<ScopeCityCostDTO> page = scopeCityCostService.page(params);

        return new Result<PageData<ScopeCityCostDTO>>().ok(page);
    }

    @GetMapping("{id}")
    @ApiOperation("信息")
    @RequiresPermissions("sys:scopecitycost:info")
    public Result<ScopeCityCostDTO> get(@PathVariable("id") Long id){
        ScopeCityCostDTO data = scopeCityCostService.get(id);

        return new Result<ScopeCityCostDTO>().ok(data);
    }

    @PostMapping
    @ApiOperation("保存")
    @LogOperation("保存")
    @RequiresPermissions("sys:scopecitycost:save")
    public Result save(@RequestBody ScopeCityCostDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);

        //日期+城市+账户id 唯一性校验
        Map<String,Object> params = new HashMap<>();
        params.put("city",dto.getCity()+"");
        params.put("date", DateUtils.format(dto.getDate()));
        params.put("advertiserId",dto.getAdvertiserId()+"");
        List<ScopeCityCostDTO> repeatList = scopeCityCostService.list(params);
        if (!CollectionUtils.isEmpty(repeatList)){
            throw new RenException("记录已存在");
        }

        UserDetail userDetail = SecurityUser.getUser();
        dto.setCreateBy(userDetail.getId());
//        dto.setUpdateBy(userDetail.getId());
        dto.setCreateTime(new Date());
//        dto.setUpdateTime(new Date());
        RdAdvertiserEntity advertiserEntity = rdAdvertiserDao.selectOne(new QueryWrapper<RdAdvertiserEntity>().eq("status",1)
                .eq("advertiser_id",dto.getAdvertiserId()).last("limit 1"));
        if (advertiserEntity!=null){
            dto.setAdvertiserName(advertiserEntity.getAdvertiserName());
        }
        scopeCityCostService.save(dto);

        return new Result();
    }

    @PutMapping
    @ApiOperation("修改")
    @LogOperation("修改")
    @RequiresPermissions("sys:scopecitycost:update")
    public Result update(@RequestBody ScopeCityCostDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);

        //日期+城市+账户id 唯一性校验
        Map<String,Object> params = new HashMap<>();
        params.put("city",dto.getCity()+"");
        params.put("date", DateUtils.format(dto.getDate()));
        params.put("advertiserId",dto.getAdvertiserId()+"");
        List<ScopeCityCostDTO> repeatList = scopeCityCostService.list(params);
        if (!CollectionUtils.isEmpty(repeatList)){
            for (ScopeCityCostDTO scopeCityCostDTO:repeatList){
                if (scopeCityCostDTO.getId().longValue()!=dto.getId().longValue()){
                    throw new RenException("记录已存在");
                }
            }
        }

        UserDetail userDetail = SecurityUser.getUser();
        dto.setUpdateBy(userDetail.getId());
        dto.setUpdateTime(new Date());
        scopeCityCostService.update(dto);

        return new Result();
    }

    @DeleteMapping
    @ApiOperation("删除")
    @LogOperation("删除")
    @RequiresPermissions("sys:scopecitycost:delete")
    public Result delete(@RequestBody Long[] ids){
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");
        UserDetail userDetail = SecurityUser.getUser();
        for (Long id:ids){
            ScopeCityCostDTO dto = scopeCityCostService.get(id);
            dto.setDeleteTime(new Date());
            dto.setStatus(0);
            dto.setUpdateBy(userDetail.getId());
            scopeCityCostService.update(dto);
        }

        return new Result();
    }

    @GetMapping("export")
    @ApiOperation("导出")
    @LogOperation("导出")
    @RequiresPermissions("sys:scopecitycost:export")
    public void export(@ApiIgnore @RequestParam Map<String, Object> params, HttpServletResponse response) throws Exception {
        List<ScopeCityCostDTO> list = scopeCityCostService.list(params);

        ExcelUtils.exportExcelToTarget(response, null, list, ScopeCityCostExcel.class);
    }

}